﻿////////////////////
//
//   Globalization.js
//   2017.08.09
//
//   Globalization
//   1.日期格式各国国对应
//   2.文字对应
//   3.查找用户手机设置国家/地区对应广告
//
////////////////////
var LocaleName="";//手机设定国家/地区：
               //zh-CN,zh-HK,zh-SG,zh-TW; Hant:繁体字
               //ja-JP;
               //en-AU,en-CA,en-GB,en-IE,en-IN,en-NZ,en-SG,en-US,en-ZA;
               //fr-FR; de-DE; it-IT; nl-NL,nl-BE; 
               //es-AR Spanish (Argentina), es-ES Spanish (Spain), es-UY Spanish (Uruguay), es-MX Spanish(Mexico)
               //pt-BR Portuguese(Brazil), pt-PT Portuguese(Portugal)

//---各くにの文字列：
var tops_str, bottoms_str, suit_str, dress_str, coat_str, shoes_str, bag_str, others_str;
var property_str, one_image_str, list_str, help_str, max_str, favorite_str, use_date_str;

//---Get用户手机设置国家/地区:
function getLocaleName() {
   LocaleName = "zh-CN";//缺省值：中国

   navigator.globalization.getLocaleName(onSuccess, onError);

   function onSuccess(locale) {
      console.log('locale: ' + locale.value);//ja-JP
      //alert('locale: ' + locale.value);//ja-JP
      LocaleName = locale.value;
   }

   function onError(){
      LocaleName = "zh-CN";//缺省值：中国
      console.log('Error getting locale');
   }
	
}

function getLocaleName1(onEndfunction) {
   LocaleName = "en-US";//缺省值：中国

   navigator.globalization.getLocaleName(
                function(locale, onEndfunction){
                   onSuccess(locale);
                   onEndfunctionDo(onEndfunction);
                },
                function(onEndfunction){
                   onError();
                   onEndfunctionDo(onEndfunction);
                }
             );

   function onSuccess(locale) {
      console.log('locale: ' + locale.value);//ja-JP
      LocaleName = locale.value;

   }

   function onError(onEndfunction){
      LocaleName = "en-US";//缺省值：中国
      console.log('Error getting locale');
   }

   function onEndfunctionDo(){
      onEndfunction();
   }
}


//--- string by country
function String_Bycountry(str_en)
{
   if(LocaleName.indexOf("zh") >= 0 && (LocaleName.indexOf("Hant") >= 0 || LocaleName.indexOf("HK") >=0 || LocaleName.indexOf("TW") >=0)){
       return GetString_cn_Hant(str_en);
   }
   if(LocaleName.indexOf("zh") >= 0 && LocaleName.indexOf("Hant") < 0 ){
       return GetString_cn(str_en);
   }
   if(LocaleName.indexOf("ja") >= 0){
       return GetString_ja(str_en);
   }
   return str_en;

   //---cn
   function GetString_cn(str_en)
   {
       var str_now = str_en;
       //---index.html
       if(str_en == "Delete the Item and the Relating ?"){ str_now = "是否删除这个照片和记录信息？"; }
       //---dbdeit.html
       if(str_en == "Inputted message will disappear!"){ str_now = "是否保存变更信息？"; }
       if(str_en == "Are you need to save the New message ?"){ str_now = "是否保存变更信息？"; }
       if(str_en == "Are you need to save the New photo ?"){ str_now = "是否保存新照片？"; }
       if(str_en == "Saved then Item"){ str_now = "已经保存"; }
       if(str_en == "Modify the item's message"){ str_now = "更改"; }
       if(str_en == "Add the item"){ str_now = "添加"; }
       if(str_en == "Add then New-Item"){ str_now = "已经添加"; }
       //---UseDateOne.html
       if(str_en == "Saved the Items at Album"){ str_now = "已经保存到相册"; }
       if(str_en == "Delete the Coordinates?"){ str_now = "是否删除这个衣物搭配组合？"; }
       if(str_en == "Saved the Items"){ str_now = "已经保存"; }
       if(str_en == "Favorite"){ str_now = "收藏"; }
       if(str_en == "Set use date"){ str_now = "使用日期"; }
       if(str_en == "Need add the new clothes photo."){ str_now = "请添加新衣物照片"; }

       return str_now;
   }
   //---cn Hant
   function GetString_cn_Hant(str_en)
   {
       var str_now = str_en;
       //---index.html
       if(str_en == "Delete the Item and the Relating ?"){ str_now = "是否刪除這個照片和記錄資訊？"; }
       //---dbdeit.html
       if(str_en == "Inputted message will disappear!"){ str_now = "是否保存變更資訊？"; }
       if(str_en == "Are you need to save the New message ?"){ str_now = "是否保存變更資訊？"; }
       if(str_en == "Are you need to save the New photo ?"){ str_now = "是否保存新照片？"; }
       if(str_en == "Saved then Item"){ str_now = "已經保存"; }
       if(str_en == "Modify the item's message"){ str_now = "變更"; }
       if(str_en == "Add the item"){ str_now = "增加"; }
       if(str_en == "Add then New-Item"){ str_now = "已經保存"; }

       //---UseDateOne.html
       if(str_en == "Saved the Items at Album"){ str_now = "已經保存到相冊"; }
       if(str_en == "Delete the Coordinates?"){ str_now = "是否刪除這個衣物搭配組合？"; }
       if(str_en == "Saved the Items"){ str_now = "已經保存"; }
       if(str_en == "Favorite"){ str_now = "收藏"; }
       if(str_en == "Set use date"){ str_now = "使用日期"; }
       if(str_en == "Need add the new clothes photo."){ str_now = "請添加新衣物照片"; }

       return str_now;
   }
   //---ja
   function GetString_ja(str_en)
   {
       var str_now = str_en;
       //---index.html
       if(str_en == "Delete the Item and the Relating ?"){ str_now = "削除しますか?"; }
       //---dbdeit.html
       if(str_en == "Inputted message will disappear!"){ str_now = "変更された情報は保存しますか?"; }
       if(str_en == "Are you need to save the New message ?"){ str_now = "変更された情報は保存しますか?"; }
       if(str_en == "Are you need to save the New photo ?"){ str_now = "新しい写真は保存しますか?"; }
       if(str_en == "Saved then Item"){ str_now = "保存しました"; }
       if(str_en == "Modify the item's message"){ str_now = "変更"; }
       if(str_en == "Add the item"){ str_now = "追加"; }
       if(str_en == "Add then New-Item"){ str_now = "追加しました"; }
       //---UseDateOne.html
       if(str_en == "Saved the Items at Album"){ str_now = "アルバムに保存しました"; }
       if(str_en == "Delete the Coordinates?"){ str_now = "削除しますか?"; }
       if(str_en == "Saved the Items"){ str_now = "保存しました"; }
       if(str_en == "Favorite"){ str_now = "お気に入り"; }
       if(str_en == "Set use date"){ str_now = "使用日"; }
       if(str_en == "Need add the new clothes photo."){ str_now = "新しい洋服写真を追加してください"; }

       return str_now;
   }
}
