﻿////////////////////
//
//   histogram-canvas.js
//   histogram and canvas draw
//   2017.12.19
//
////////////////////
var histogram_list=[], col_max=512;//4096;
var col_peak_list=[], col_peak_max=16;

    init_histogram_list();
    init_col_peak_list();

function init_histogram_list()
{
    for(var i=0; i<col_max; i++){
        histogram_list.push(0);
        //histogram_list[i]=[0]; //[color is No of array, No of color is value]
    }
}
function init_col_peak_list()
{
    for(var i=0; i<col_peak_max; i++){
        col_peak_list[i]=[0,0]; //[ 0:color, 1:color-data-No. ]
    }
}

function histogram_col_list_set0()
{
    for(var i=0; i<col_max; i++){
        histogram_list[i]=0; //[color is No of array, No of color is value]
    }
}

//---
function histogram(img_obj, f_type)
{

    var canvas = document.createElement("canvas");
    canvas.width = img_obj.naturalWidth;
    canvas.height = img_obj.naturalHeight;

    var ctx = canvas.getContext("2d");
    ctx.drawImage(img_obj, 0,0,img_obj.naturalWidth, img_obj.naturalHeight, 0,0, canvas.width, canvas.height);

    //---
    var pixelData = ctx.getImageData(0, 0, canvas.width, canvas.height).data;
    var dy;
    var pos;
    var r, g, b, a;
    var col_value;

    var old_d = new Date();

    histogram_col_list_set0();
    init_col_peak_list();

    for(var y=0; y<canvas.height; y++){
        for(var x=0; x<canvas.width; x++){
            //---
            dy = y * canvas.width * 4;
            pos = dy + x * 4;
            r = pixelData[pos+0]>>>5;//4;//r right shift 4bit
            g = pixelData[pos+1]>>>5;//4;//g right shift 4bit
            b = pixelData[pos+2]>>>5;//4;//b right shift 4bit
            a = pixelData[pos+3];//a(alpha)
            //if(x==244 && y==296){//test
            //   var tmp = a;
            //}
            //---set histogram:
            //col_value = r*256 + g*16 + b;//4bit,4bit,4bit
            col_value = r*64 + g*8 + b;//3bit,3bit,3bit
            histogram_list[col_value]++;
        }
    }

    //---find peak:
    var min_i=0, min_d=histogram_list[1], min_count=1;//cut 0,0,0 & 255,255,255
    var max_i=0, max_d=histogram_list[1], max_count=1;//cut 0,0,0 & 255,255,255
    for(i=1; i<col_max; i++){
         //if(i>4093){
         //   var a="end";
         //}
         //--up
         if(histogram_list[i] <= histogram_list[i+1]){
              max_d = histogram_list[i+1];
              max_i = i+1;
              max_count++;

              min_count = 0;
         }
         if(histogram_list[i] >= histogram_list[i+1]){
              min_d = histogram_list[i+1];
              min_i = i+1;
              if(min_count == 0){ set_peak_array(max_i, max_d); }
              min_count++;

              max_count = 0;
         }
    }
    //---sort by color-data-No
    col_peak_list = col_peak_list.sort(
              function(x, y){
                 return x[1] < y[1] ? 1 : -1;  //color-data-No降順
              });

    var new_d, sec;

    //--- get メイン色
    if(f_type.indexOf("upper") >= 0 || f_type.indexOf("Bottom") >= 0 || f_type.indexOf("one-piece") >= 0){
        histogram_col_list_set0();
        //---
        for(var y=Math.round(canvas.height/4); y<Math.round(canvas.height*3/4); y++){
            for(var x=Math.round(canvas.width/4); x<Math.round(canvas.width*3/4); x++){
                //---
                dy = Math.round(y * canvas.width * 4);
                pos = dy + Math.round(x * 4);
                r = pixelData[pos+0]>>>5;//4;//r right shift 4bit
                g = pixelData[pos+1]>>>5;//4;//g right shift 4bit
                b = pixelData[pos+2]>>>5;//4;//b right shift 4bit
                a = pixelData[pos+3];//a(alpha)
                //---set histogram:
                //col_value = r*256 + g*16 + b;//4bit,4bit,4bit
                col_value = r*64 + g*8 + b;//3bit,3bit,3bit
                histogram_list[col_value]++;
            }
        }        
        //---find peak:
        var big_col=0, big_No=histogram_list[0];
        for(i=1; i<col_max; i++){
            if(big_No < histogram_list[i]){
               big_col=i; big_No=histogram_list[i]; 
            }
        }
        //---end time:
        new_d = new Date();//PC use 1101msec
        sec = new_d - old_d;
        console.log( " histogram1 msec: " + sec + " w/h:"+ canvas.width + "/" +canvas.height +" " + f_type);

        //---カラー列つ
        return(('000'+big_col).slice(-3)+"-"+('000'+col_peak_list[1][0]).slice(-3)
          +"-"+('000'+col_peak_list[2][0]).slice(-3)+"-"+('000'+col_peak_list[3][0]).slice(-3)
          +"-"+('000'+col_peak_list[4][0]).slice(-3)+"-"+('000'+col_peak_list[5][0]).slice(-3)
          +"-"+('000'+col_peak_list[6][0]).slice(-3)+"-"+('000'+col_peak_list[7][0]).slice(-3)
          +"-"+('000'+col_peak_list[8][0]).slice(-3)+"-"+('000'+col_peak_list[9][0]).slice(-3)
          +"-"+('000'+col_peak_list[10][0]).slice(-3)+"-"+('000'+col_peak_list[11][0]).slice(-3)
          +"-"+('000'+col_peak_list[12][0]).slice(-3)+"-"+('000'+col_peak_list[13][0]).slice(-3)
          +"-"+('000'+col_peak_list[14][0]).slice(-3)+"-"+('000'+col_peak_list[15][0]).slice(-3));

        //return(big_col+"-"+col_peak_list[1][0]+"-"+col_peak_list[2][0]+"-"+col_peak_list[3][0]
        //  +"-"+col_peak_list[4][0]+"-"+col_peak_list[5][0]+"-"+col_peak_list[6][0]+"-"+col_peak_list[7][0]
        //  +"-"+col_peak_list[8][0]+"-"+col_peak_list[9][0]+"-"+col_peak_list[10][0]+"-"+col_peak_list[11][0]
        //  +"-"+col_peak_list[12][0]+"-"+col_peak_list[13][0]+"-"+col_peak_list[14][0]+"-"+col_peak_list[15][0]);
    }

    //---end time:
    new_d = new Date();//PC use 1101msec
    sec = new_d - old_d;
    console.log( " histogram0 msec: " + sec + " w/h:"+ canvas.width + "/" +canvas.height +" " + f_type);

    //---カラー列つ
    return(('000'+col_peak_list[0][0]).slice(-3)+"-"+('000'+col_peak_list[1][0]).slice(-3)
      +"-"+('000'+col_peak_list[2][0]).slice(-3)+"-"+('000'+col_peak_list[3][0]).slice(-3)
      +"-"+('000'+col_peak_list[4][0]).slice(-3)+"-"+('000'+col_peak_list[5][0]).slice(-3)
      +"-"+('000'+col_peak_list[6][0]).slice(-3)+"-"+('000'+col_peak_list[7][0]).slice(-3)
      +"-"+('000'+col_peak_list[8][0]).slice(-3)+"-"+('000'+col_peak_list[9][0]).slice(-3)
      +"-"+('000'+col_peak_list[10][0]).slice(-3)+"-"+('000'+col_peak_list[11][0]).slice(-3)
      +"-"+('000'+col_peak_list[12][0]).slice(-3)+"-"+('000'+col_peak_list[13][0]).slice(-3)
      +"-"+('000'+col_peak_list[14][0]).slice(-3)+"-"+('000'+col_peak_list[15][0]).slice(-3));

    //return(col_peak_list[0][0]+"-"+col_peak_list[1][0]+"-"+col_peak_list[2][0]+"-"+col_peak_list[3][0]
    //  +"-"+col_peak_list[4][0]+"-"+col_peak_list[5][0]+"-"+col_peak_list[6][0]+"-"+col_peak_list[7][0]
    //  +"-"+col_peak_list[8][0]+"-"+col_peak_list[9][0]+"-"+col_peak_list[10][0]+"-"+col_peak_list[11][0]
    //  +"-"+col_peak_list[12][0]+"-"+col_peak_list[13][0]+"-"+col_peak_list[14][0]+"-"+col_peak_list[15][0]);
}

//---
function set_peak_array(max_i, max_no)
{
    for(var i=0; i<col_peak_max; i++){
        if(max_no > col_peak_list[i][1]){//[ 0:color, 1:color-data-No. ]
            col_peak_list[i][0] = max_i;
            col_peak_list[i][1] = max_no;
            break;
        }
    }
    //---sort by color-data-No
    col_peak_list = col_peak_list.sort(
              function(x, y){
                 return x[1] > y[1] ? 1 : -1;  //color-data-No升順
              });
}

function draw_histogram(canvas_his)
{
   ;
}
